Botan: Botan::Bzip_Decompression Class Reference

Botan 1.10.17

Public Member Functions | Protected Member Functions | List of all members
Botan::Bzip_Decompression Class Reference

`#include <bzip2.h>`

Inheritance diagram for Botan::Bzip_Decompression:

## Public Member Functions
virtual bool | attachable ()
| Bzip_Decompression (bool=false)
void | end_msg ()
std::string | name () const
void | start_msg ()
void | write (const byte input[], size_t length)
| ~Bzip_Decompression ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

Bzip Decompression Filter

Definition at line 43 of file bzip2.h.

## Constructor & Destructor Documentation

## ◆ Bzip_Decompression()

Botan::Bzip_Decompression::Bzip_Decompression | ( | bool | s = `false` | ) |

Definition at line 184 of file bzip2.cpp.

184 :
185 small_mem(s), buffer(DEFAULT_BUFFERSIZE)
186 {
187 no_writes = true;
188 bz = 0;
189 }

## ◆ ~Bzip_Decompression()

Botan::Bzip_Decompression::~Bzip_Decompression | ( |  | ) |
| inline

Definition at line 53 of file bzip2.h.

53 { clear(); }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::Bzip_Decompression::end_msg | ( |  | ) |
| virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 255 of file bzip2.cpp.

References Botan::MemoryRegion< T >::begin(), Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

256 {
257 if(no_writes) return;
258 bz->stream.next_in = 0;
259 bz->stream.avail_in = 0;
260
261 int rc = BZ_OK;
262 while(rc != BZ_STREAM_END)
263 {
264 bz->stream.next_out = reinterpret_cast<char*>(buffer.begin());
265 bz->stream.avail_out = buffer.size();
266 rc = BZ2_bzDecompress(&(bz->stream));
267
268 if(rc != BZ_OK && rc != BZ_STREAM_END)
269 {
270 clear();
271 throw Decoding_Error("Bzip_Decompression: Error finalizing");
272 }
273
274 send(buffer, buffer.size() - bz->stream.avail_out);
275 }
276
277 clear();
278 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::MemoryRegion::begin
T * begin()
Definition: secmem.h:59

## ◆ name()

std::string Botan::Bzip_Decompression::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 46 of file bzip2.h.

46 { return "Bzip_Decompression"; }

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::MemoryRegion< T >::size(), and Botan::Filter::write().

Referenced by Botan::PK_Encryptor_Filter::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Zlib_Compression::write(), Botan::Bzip_Compression::write(), Botan::StreamCipher_Filter::write(), write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:158
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ start_msg()

void Botan::Bzip_Decompression::start_msg | ( |  | ) |
| virtual

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented from Botan::Filter.

Definition at line 241 of file bzip2.cpp.

Referenced by write().

242 {
243 clear();
244 bz = new Bzip_Stream;
245
246 if(BZ2_bzDecompressInit(&(bz->stream), 0, small_mem) != BZ_OK)
247 throw Memory_Exhaustion();
248
249 no_writes = true;
250 }

## ◆ write()

void Botan::Bzip_Decompression::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 194 of file bzip2.cpp.

References Botan::MemoryRegion< T >::begin(), Botan::Filter::send(), Botan::MemoryRegion< T >::size(), and start_msg().

195 {
196 if(length) no_writes = false;
197
198 char* input = reinterpret_cast<char*>(const_cast<byte*>(input_arr));
199
200 bz->stream.next_in = input;
201 bz->stream.avail_in = length;
202
203 while(bz->stream.avail_in != 0)
204 {
205 bz->stream.next_out = reinterpret_cast<char*>(buffer.begin());
206 bz->stream.avail_out = buffer.size();
207
208 int rc = BZ2_bzDecompress(&(bz->stream));
209
210 if(rc != BZ_OK && rc != BZ_STREAM_END)
211 {
212 clear();
213
214 if(rc == BZ_DATA_ERROR)
215 throw Decoding_Error("Bzip_Decompression: Data integrity error");
216 else if(rc == BZ_DATA_ERROR_MAGIC)
217 throw Decoding_Error("Bzip_Decompression: Invalid input");
218 else if(rc == BZ_MEM_ERROR)
219 throw Memory_Exhaustion();
220 else
221 throw std::runtime_error("Bzip2 decompression: Unknown error");
222 }
223
224 send(buffer, buffer.size() - bz->stream.avail_out);
225
226 if(rc == BZ_STREAM_END)
227 {
228 size_t read_from_block = length - bz->stream.avail_in;
229 start_msg();
230 bz->stream.next_in = input + read_from_block;
231 bz->stream.avail_in = length - read_from_block;
232 input += read_from_block;
233 length -= read_from_block;
234 }
235 }
236 }
Botan::byte
unsigned char byte
Definition: types.h:22
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::MemoryRegion::begin
T * begin()
Definition: secmem.h:59
Botan::Bzip_Decompression::start_msg
void start_msg()
Definition: bzip2.cpp:241

The documentation for this class was generated from the following files:

- src/filters/bzip2/bzip2.h
- src/filters/bzip2/bzip2.cpp